unit Scanform;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, DB, DBTables;

type
  TScannerTestForm = class(TForm)
    CountryTable: TTable;
    ListCountriesButton: TButton;
    ListBigCountriesButton: TButton;
    procedure ListCountriesButtonClick(Sender: TObject);
    procedure ListBigCountriesButtonClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  ScannerTestForm: TScannerTestForm;

implementation

uses Scanners;

{$R *.DFM}

procedure ShowCountry( ATable: TTable ); far;
begin
  messageBeep( $FFFF );
  showMessage( ATable.FieldByName( 'Name' ).AsString );
end;

procedure TScannerTestForm.ListCountriesButtonClick(Sender: TObject);
var
  MyScanner: TTableActionScanner ;
begin
  MyScanner := TTableActionScanner.Create(
    CountryTable,
    ShowCountry
  );
  MyScanner.Execute;
  MyScanner.Free;
end;

function BigCountry( SourceTable: TTable ): Boolean; far;
begin
 Result :=
   (SourceTable.FieldByName( 'Area' ).AsInteger > 2000000);
end;

procedure TScannerTestForm.ListBigCountriesButtonClick(
  Sender: TObject);
var
  MyScanner: TTableActionScanner ;
begin
  MyScanner := TTableConditionalActionScanner.Create(
    CountryTable,
    ShowCountry,
    BigCountry
  );
  MyScanner.Execute;
  MyScanner.Free;
end;

end.
